import es, os.path
import playerlib, gamethread, cfglib, popuplib, langlib, usermsg, random, pickle

config = cfglib.AddonCFG(es.getAddonPath('bdm') + '/bdm.cfg')

config.text('BDM (BackRaw\'s DeathMatch) by BackRaw')
config.text('SETTINGS - VERSION 1.2')

config.text('\n')
config.text('***********************')
config.text(' -> Make BDM Public <- ')
config.text('***********************')
bdm_version = config.cvar('bdm_version', 1.3)
config.text('\n')
##config.text('****************')
##config.text(' -> GunGame? <- ')
##config.text('****************')
##bdm_gungame = config.cvar('bdm_gungame', 1, 'Is your server running GunGame (or something similar)?')
##config.text('\n')
config.text('*********************')
config.text(' -> FF On? Noisy? <- ')
config.text('*********************')
bdm_ff = config.cvar('bdm_ff', 0, 'On = 1, Off = 0')
bdm_noisy = config.cvar('bdm_noisy', 0, 'Does another script use eventscripts_noisy? (Yes = 1, No = 0)')
config.text('\n')
config.text('*******************')
config.text(' -> BOT-WEAPONS <- ')
config.text('*******************')
bdm_bot_prim_weps = config.cvar('bdm_bot_prim_weps', 'ak47,m4a1,galil,famas', 'Primary Bot-Weapons')
bdm_bot_sec_weps = config.cvar('bdm_bot_sec_weps', 'usp,deagle,fiveseven', 'Secondary Bot-Weapons')
config.text('\n')
config.text('********************************************')
config.text(' -> RESPAWN - SPAWN-PROTECTION - SPAWNPOINTS')
config.text('********************************************')
bdm_respawn = config.cvar('bdm_respawn', .75, 'How long should a respawn take?')
bdm_spawnprotection = config.cvar('bdm_spawnprotection', 1, 'Enable/disable spawn-protection')
bdm_spawnprotectiontime = config.cvar('bdm_spawnprotectiontime', 2, 'How long should the spawn-protection take?')
bdm_spawnprotectioncolor_t = config.cvar('bdm_spawnprotectioncolor_t', '255, 0, 0, 105', 'Set the protection-color for Terrorists')
bdm_spawnprotectioncolor_ct = config.cvar('bdm_spawnprotectioncolor_ct', '0, 0, 255, 105', 'Set the protection-color for Counter-Terrorists')
bdm_spawnpoints = config.cvar('bdm_spawnpoints', 1, 'Use spawn-points?')
config.text('\n')
config.text('********************************************************')
config.text(' -> REMOVE WEAPONS, ENITIES, CORPSES, AND OBJECTIVES <- ')
config.text('********************************************************')
bdm_removecorpses = config.cvar('bdm_removecorpses', 1, 'Should corpses be removed?')
bdm_removecorpsestime = config.cvar('bdm_removecorpsestime', 3, 'Seconds to wait before the corpses are removed')
bdm_removeobjectives = config.cvar('bdm_removeobjectives', 1, 'Should objectives be removed?')
config.text('\n')
config.text('**********************************************************')
config.text(' -> REFILL AMMO? ENABLE AWP? GIVE WEAPON BACK AT DROP? <- ')
config.text('**********************************************************')
bdm_refillammo = config.cvar('bdm_refillammo', 1, 'Should ammo be refilled? (requires eventscripts_noisy to be set to 1, like bdm_noisy 0 does)')
bdm_awp = config.cvar('bdm_awp', 0, 'Should AWP be available to use?')
bdm_give_dropped = config.cvar('bdm_give_dropped', 1, 'Give the dropped weapon back?')
config.text('\n')
config.text('*******************')
config.text(' -> Show-Damage <- ')
config.text('*******************')
bdm_sd = config.cvar('bdm_sd', 1, 'Enable/disable Show-Damage')

config.write()

random_sec = ('weapon_glock;weapon_usp;weapon_deagle;weapon_fiveseven;weapon_elite;weapon_p228')
if bdm_awp == 1:
    random_prim = ('weapon_m4a1;weapon_ak47;weapon_galil;weapon_famas;weapon_sg552;weapon_aug;weapon_scout;weapon_m3;weapon_awp;weapon_xm1014;weapon_tmp;weapon_mac10', 'weapon_mp5navy;weapon_ump45;weapon_p90;weapon_m249')
else:
    random_prim = ('weapon_m4a1;weapon_ak47;weapon_galil;weapon_famas;weapon_sg552;weapon_aug;weapon_scout;weapon_m3;weapon_xm1014;weapon_tmp;weapon_mac10', 'weapon_mp5navy;weapon_ump45;weapon_p90;weapon_m249')
bdm_menu = 0
bdm_prim_menu = 0
bdm_sec_menu = 0
choose_menu = 0
settings_menu = 0
bdm_playerlist = {}
settings = {}

def load():
    global bdm_menu, bdm_prim_menu, bdm_sec_menu, choose_menu, settings, settings_menu
    config.execute()
    es.ServerVar('BackRaw\'s Deathmatch', str(bdm_version)).makepublic()
    if bdm_noisy == 0:
        es.set('eventscripts_noisy', '1')
    if bdm_ff == 1:
        es.set('mp_friendlyfire', '1')
    else:
        es.set('mp_friendlyfire', '0')
    if bdm_spawnpoints == 1:
        es.reload('smartspawns')
    else:
        es.unload('smartspawns')
    settings_menu = popuplib.easymenu('settings_men', '_popup_choice', player_set_men)
    settings_menu.settitle('Player-Settings Menu')
    settings_menu.addoption('sd_give', 'Show-Damage "Give" - On')
    settings_menu.addoption('sd_take', 'Show-Damage "Take" - On')
    bdm_menu = popuplib.easymenu('bdm_weps', '_popup_choice', menu)
    bdm_menu.settitle('Weapon-Menu')
    bdm_menu.addoption('newweps', 'New Equipment')
    bdm_menu.addoption('random', 'Random weapons')
    choose_menu = popuplib.easymenu('choose_again_never', '_popup_chocie', again_never)
    choose_menu.settitle('Show Again or Never Display?')
    choose_menu.addoption('show_again', 'Display this menu again, and choose same weapons')
    choose_menu.addoption('never_display', 'Never display this menu again, but choose same weapons')
    bdm_sec_menu = popuplib.easymenu('bdm_sec', '_popup_choice', chosen_sec)
    bdm_sec_menu.settitle('Choose a secondary weapon')
    bdm_sec_menu.addoption('none', 'No Secondary')
    bdm_sec_menu.addoption('usp', 'USP')
    bdm_sec_menu.addoption('glock', 'Glock 18C')
    bdm_sec_menu.addoption('deagle', 'Desert Eagle')
    bdm_sec_menu.addoption('p228', 'P228')
    bdm_sec_menu.addoption('fiveseven', 'ES Five-Seven')
    bdm_sec_menu.addoption('elite', 'Dual .40 Berettas')
    bdm_prim_menu = popuplib.easymenu('bdm_prim', '_popup_choice', chosen_prim)
    bdm_prim_menu.settitle('Choose a primary weapon')
    bdm_prim_menu.addoption('none', 'No Primary')
    bdm_prim_menu.addoption('m4a1', 'Maverick M4A1 Carbine')
    bdm_prim_menu.addoption('ak47', 'Avtomat Kalashnikova - 47')
    bdm_prim_menu.addoption('galil', 'IMI Galil')
    bdm_prim_menu.addoption('famas', 'FAMAS')
    bdm_prim_menu.addoption('sg552', 'SG-552 Commando')
    bdm_prim_menu.addoption('aug', 'Steyr AUG')
    bdm_prim_menu.addoption('scout', 'Steyr Scout')
    if bdm_awp == 1:
        bdm_prim_menu.addoption('awp', 'Artic Warfare Police (AWP)')
    bdm_prim_menu.addoption('m3', 'M3 Super 90 Entry')
    bdm_prim_menu.addoption('xm1014', 'XM1014 (M4 Super 90)')
    bdm_prim_menu.addoption('tmp', 'Tactical Mashine Pistol (TMP)')
    bdm_prim_menu.addoption('mac10', 'Ingram MAC-10')
    bdm_prim_menu.addoption('mp5navy', 'MP5-Navy')
    bdm_prim_menu.addoption('ump45', 'Universal Mashine Pistol (UMP 45)')
    bdm_prim_menu.addoption('p90', 'P90')
    bdm_prim_menu.addoption('m249', 'M249 Para')
    if not es.exists('saycommand', 'guns'):
        es.regsaycmd('guns', 'bdm/guns')
    if not es.exists('saycommand', 'bdm'):
        es.regsaycmd('bdm', 'bdm/player_settings')
    settings_file = es.getAddonPath('bdm') + '/settings.db'
    if os.path.isfile(settings_file):
        file_settings = open(settings_file)
        settings = pickle.load(file_settings)
        file_settings.close()
    for player in playerlib.getUseridList('#all'):
        user = playerlib.uniqueid(player, True)
        if not user in bdm_playerlist:
            default(user)
        if not user in settings:
            default_settings(user)

def unload():
    bdm_menu.delete()
    bdm_sec_menu.delete()
    bdm_prim_menu.delete()
    choose_menu.delete()
    bdm_playerlist.clear()
    es.unregsaycmd('guns')
    es.unregsaycmd('bdm')
    save_file()
    if bdm_removeobjectives == 1:
        for userid in playerlib.getUseridList('#all'):
            es.server.cmd('es_xfire %s func_buyzone enable;es_xfire %s func_bomb_target ebable;es_xfire %s func_hostage_rescue ebable' % (userid, userid, userid))

def player_settings():
    userid = es.getcmduserid()
    settings_menu.send(userid)

def player_set_men(userid, choice, popupid):
    global settings_menu, settings
    user = playerlib.uniqueid(userid, True)
    if choice == 'sd_give':
        if settings[user]['sd_give'] == 1:
            settings_menu.setoption('sd_give', 'Show-Damage "Give" - Off')
            settings[user]['sd_give'] = 0
        else:
            settings_menu.setoption('sd_give', 'Show-Damage "Give" - On')
            settings[user]['sd_give'] = 1
        settings_menu.send(userid)
    elif choice == 'sd_take':
        if settings[user]['sd_take'] == 1:
            settings_menu.setoption('sd_take', 'Show-Damage "Take" - Off')
            settings[user]['sd_take'] = 0
        else:
            settings_menu.setoption('sd_take', 'Show-Damage "Take" - On')
            settings[user]['sd_take'] = 1
        settings_menu.send(userid)

def weapon_reload(ev):
    userid = ev['userid']
    if bdm_refillammo == 1:
        weaponammo(userid)

def weapon_fire_on_empty(ev):
    userid = ev['userid']
    if bdm_refillammo == 1:
        weaponammo(userid)

def weaponammo(userid):
    user = playerlib.getPlayer(userid)
    player = playerlib.getPlayer(userid)
    if bdm_awp == 1:
        if player.get('weapon') == 'weapon_awp':
            user.set('ammo', ['primary', '30'])
    if player.get('weapon') == 'weapon_glock':
        user.set('ammo', ['secondary', '120'])
    elif player.get('weapon') == 'weapon_usp':
        user.set('ammo', ['secondary', '100'])
    elif player.get('weapon') == 'weapon_p228':
        user.set('ammo', ['secondary', '52'])
    elif player.get('weapon') == 'weapon_deagle':
        user.set('ammo', ['secondary', '35'])
    elif player.get('weapon') == 'weapon_fiveseven':
        user.set('ammo', ['secondary', '100'])
    elif player.get('weapon') == 'weapon_elite':
        user.set('ammo', ['secondary', '120'])
    elif player.get('weapon') == 'weapon_m4a1':
        user.set('ammo', ['primary', '90'])
    elif player.get('weapon') == 'weapon_ak47':
        user.set('ammo', ['primary', '90'])
    elif player.get('weapon') == 'weapon_galil':
        user.set('ammo', ['primary', '90'])
    elif player.get('weapon') == 'weapon_famas':
        user.set('ammo', ['primary', '90'])
    elif player.get('weapon') == 'weapon_sg552':
        user.set('ammo', ['primary', '90'])
    elif player.get('weapon') == 'weapon_aug':
        user.set('ammo', ['primary', '90'])
    elif player.get('weapon') == 'weapon_scout':
        user.set('ammo', ['primary', '90'])
    elif player.get('weapon') == 'weapon_m3':
        user.set('ammo', ['primary', '32'])
    elif player.get('weapon') == 'weapon_xm1014':
        user.set('ammo', ['primary', '32'])
    elif player.get('weapon') == 'weapon_tmp':
        user.set('ammo', ['primary', '120'])
    elif player.get('weapon') == 'weapon_mac10':
        user.set('ammo', ['primary', '100'])
    elif player.get('weapon') == 'weapon_mp5navy':
        user.set('ammo', ['primary', '120'])
    elif player.get('weapon') == 'weapon_ump45':
        user.set('ammo', ['primary', '100'])
    elif player.get('weapon') == 'weapon_p90':
        user.set('ammo', ['primary', '100'])
    elif player.get('weapon') == 'weapon_m249':
        user.set('ammo', ['primary', '200'])

def player_activate(ev):
    userid = ev['userid']
    user = playerlib.uniqueid(userid, True)
    bdm_menu.unsend(userid)
    if not user in bdm_playerlist:
        default(user)
    if not user in settings:
        default_settings(user)
    save_file()

def player_disconnect(ev):
    save_file()

def save_file():
    settings_file = open(es.getAddonPath('bdm') + '/settings.db', 'w')
    pickle.dump(settings, settings_file)
    settings_file.close()

def player_drop(ev):
    userid = ev['userid']
    weapon = ev['weapon']
    user = playerlib.uniqueid(userid, True)
    prim = bdm_playerlist[user]['primary']
    sec = bdm_playerlist[user]['secondary']
    if weapon == 'weapon_%s' % prim:
        es.server.cmd('es_xgive %s weapon_%s' % (userid, prim))
    elif weapon == 'weapon_%s' % sec:
        es.server.cmd('es_xgive %s weapon_%s' % (userid, sec))
    es.server.cmd('est_RemoveIdle weapon')

def player_spawn(ev):
    global bdm_playerlist
    userid = ev['userid']
    user = playerlib.uniqueid(userid, True)
    player = playerlib.getPlayer(userid)
    if es.getplayersteamid(userid) != 'BOT':
        if bdm_playerlist[user]['display'] == 1:
            display_uid(userid)
            gamethread.delayed(0, bdm_menu.send, (userid))
        elif bdm_playerlist[user]['never'] == 1:
            never_disp_uid(userid)
        elif bdm_playerlist[user]['randomchoice'] == 1:
            randomweps(userid)
        else:
            default(user)
            bdm_menu.send(userid)
    else:
        giveweps_bot(userid)
    if bdm_spawnprotection == 1:
        player.set('health', 9999)
        if ev['es_userteam'] == '2':
            player.set('color', str(bdm_spawnprotectioncolor_t).split(','))
        else:
            player.set('color', str(bdm_spawnprotectioncolor_ct).split(','))
        gamethread.delayed(bdm_spawnprotectiontime, player.set, ('health', 100))
        gamethread.delayed(bdm_spawnprotectiontime, player.set, ('color', (255, 255, 255, 255, 255)))
        gamethread.delayed(bdm_spawnprotectiontime, es.server.cmd, ('es_xgive %s item_assaultsuit' % userid))

def player_hurt(ev):
    dmg = ev['dmg_health']
    attacker = ev['attacker']
    userid = ev['userid']
    at = playerlib.uniqueid(attacker, True)
    us = playerlib.uniqueid(userid, True)
    if bdm_sd == 1:
        if settings[at]['sd_give'] == 1:
            es.centertell(attacker, 'Damage Given: %s' % dmg)
        if settings[us]['sd_take'] == 1:
            usermsg.hudhint(userid, 'Damage Taken: %s' % dmg)

def player_death(ev):
    userid = ev['userid']
    attacker = ev['attacker']
    weapon = ev['weapon']
    headshot = int(ev['headshot'])
    es.server.cmd('est_RemoveIdle weapon')
    gamethread.delayed(bdm_respawn, es.server.cmd, ('est_Spawn %s' % userid))
    user = playerlib.uniqueid(userid, True)
    bdm_menu.unsend(userid)
    bdm_prim_menu.unsend(userid)
    bdm_sec_menu.unsend(userid)
    choose_menu.unsend(userid)
    if bdm_removecorpses == 1:
        gamethread.delayed(bdm_removecorpsestime, es.server.cmd, ('est_RemoveIdle cs_ragdoll'))
    if headshot == 1:
        es.server.cmd('es_xgive %s weapon_hegrenade' % attacker)
    elif weapon == 'hegrenade' or weapon == 'knife':
        es.server.cmd('es_xgive %s weapon_hegrenade' % attacker)

def round_start(ev):
    es.server.cmd('est_RemoveIdle weapon')
    for player in playerlib.getUseridList('#all'):
        gamethread.delayed(2, usermsg.hudhint, (player, 'Server is running BackRaw\'s Deathmatch\nType \'guns\' to change your equipment'))
    if bdm_removeobjectives == 1:
        ts = playerlib.getUseridList('#t')
        handle = es.getplayerhandle(ts)
        es.server.cmd('est_RemoveWeapon #t 5')
        for userid in playerlib.getUseridList('#all'):
            es.server.cmd('es_xfire %s hostage_entity kill'% userid)
            es.server.cmd('es_xfire %s func_buyzone disable;es_xfire %s func_bomb_target disable;es_xfire %s func_hostage_rescue disable' % (userid, userid, userid))
            if bdm_removecorpses == 1:
                gamethread.delayed(bdm_removecorpsestime, es.server.cmd, ('est_RemoveIdle cs_ragdoll'))

def round_end(ev):
    if ev['reason'] == '10' or ev['reason'] == '16':
        for players in playerlib.getUseridList('#all'):
            bdm_menu.unsend(players)

def default(user):
    global bdm_playerlist
    bdm_playerlist[user] = {}
    bdm_playerlist[user]['secondary'] = 'none'
    bdm_playerlist[user]['primary'] = 'none'
    bdm_playerlist[user]['randomchoice'] = 0
    bdm_playerlist[user]['never'] = 0
    bdm_playerlist[user]['display'] = 0
    bdm_playerlist[user]['spawned'] = 0
    bdm_playerlist[user]['menu_opened'] = 0

def default_settings(user):
    global settings
    settings[user] = {}
    settings[user]['sd_take'] = 1
    settings[user]['sd_give'] = 1

def guns():
    global bdm_playerlist
    userid = es.getcmduserid()
    user = playerlib.uniqueid(userid, True)
    bdm_menu.send(userid)

def display_uid(userid):
    global bdm_playerlist
    user = playerlib.uniqueid(userid, True)
    bdm_playerlist[user]['never'] = 0
    bdm_playerlist[user]['display'] = 1
    bdm_playerlist[user]['randomchoice'] = 0
    strip_player(userid)
    giveweps_sec(userid)
    gamethread.delayed(0, es.sexec, (userid, 'use slot2'))
    gamethread.delayed(0, giveweps_prim, (userid))

def never_disp_uid(userid):
    global bdm_playerlist
    user = playerlib.uniqueid(userid, True)
    bdm_playerlist[user]['never'] = 1
    bdm_playerlist[user]['display'] = 0
    bdm_playerlist[user]['randomchoice'] = 0
    strip_player(userid)
    giveweps_sec(userid)
    gamethread.delayed(0, es.sexec, (userid, 'use slot2'))
    gamethread.delayed(0, giveweps_prim, (userid))
    
def menu(userid, choice, popupid):
    global bdm_playerlist
    user = playerlib.uniqueid(userid, True)
    bdm_playerlist[user]['menu_opened'] = 1
    if choice == 'newweps':
        default(user)
        bdm_sec_menu.send(userid)
    elif choice == 'random':
        bdm_playerlist[user]['never'] = 0
        bdm_playerlist[user]['display'] = 0
        bdm_playerlist[user]['randomchoice'] = 1
        randomweps(userid)
    else:
        default(user)
        bdm_menu.send(userid)

def again_never(userid, choice, popupid):
    global bdm_playerlist
    user = playerlib.uniqueid(userid, True)
    if choice == 'show_again':
        display_uid(userid)
        bdm_playerlist[user]['menu_opened'] = 0
    elif choice == 'never_display':
        never_disp_uid(userid)
        bdm_playerlist[user]['menu_opened'] = 0
    else:
        bdm_menu.send(userid)

def chosen_sec(userid, choice, popupid):
    global bdm_playerlist
    user = playerlib.uniqueid(userid, True)
    strip_player(userid)
    bdm_playerlist[user]['secondary'] = choice
    giveweps_sec(userid)
    if bdm_playerlist[user]['secondary'] != 'none':
        bdm_prim_menu.send(userid)
    else:
        choose_menu.send(userid)

def chosen_prim(userid, choice, popupid):
    global bdm_playerlist
    user = playerlib.uniqueid(userid, True)
    bdm_playerlist[user]['primary'] = choice
    choose_menu.send(userid)
    gamethread.delayed(0, giveweps_prim, (userid))

def strip_player(userid):
    es.server.cmd('es_xfire %s player_weaponstrip kill' % userid)
    es.server.cmd('es_xgive %s player_weaponstrip' % userid)
    es.server.cmd('es_xfire %s player_weaponstrip strip' % userid)
    gamethread.delayed(.1, es.server.cmd, ('es_xgive %s weapon_knife;es_xgive %s item_assaultsuit' % (userid, userid)))
    gamethread.delayed(.1, es.server.cmd, ('es_xgive %s weapon_hegrenade' % userid))

def randomweps(userid):
    playerlib.getPlayer(userid).set('health', 100)
    sec = random.choice(str(random_sec).split(';'))
    prim = random.choice(str(random_prim).split(';'))
    strip_player(userid)
    gamethread.delayed(0, es.server.cmd, ('es_xgive %s %s' % (userid, sec)))
    gamethread.delayed(.1, es.sexec, (userid, 'use slot2'))
    gamethread.delayed(.2, es.server.cmd, ('es_xgive %s %s' % (userid, prim)))
    gamethread.delayed(.3, es.sexec, (userid, 'use slot1'))

def giveweps_bot(userid):
    sec_weps = random.choice(str(bdm_bot_prim_weps).split(','))
    prim_weps = random.choice(str(bdm_bot_sec_weps).split(','))
    es.server.cmd('es_xgive %s weapon_%s;es_xgive %s weapon_%s' % (userid, sec_weps, userid, prim_weps))

def giveweps_sec(userid):
    user = playerlib.uniqueid(userid, True)
    playerlib.getPlayer(userid).set('health', 100)
    gamethread.delayed(0, es.server.cmd, ('es_xgive %s weapon_%s' % (userid, bdm_playerlist[user]['secondary'])))
    gamethread.delayed(.1, es.sexec, (userid, 'use slot2'))

def giveweps_prim(userid):
    user = playerlib.uniqueid(userid, True)
    playerlib.getPlayer(userid).set('health', 100)
    if bdm_playerlist[user]['secondary'] != 0:
        giveweps_sec(userid)
        gamethread.delayed(0, es.server.cmd, ('es_xgive %s weapon_%s' % (userid, bdm_playerlist[user]['primary'])))
        gamethread.delayed(0, es.sexec, (userid, 'use slot1'))
    else:
        gamethread.delayed(0, es.server.cmd, ('es_xgive %s weapon_%s' % (userid, bdm_playerlist[user]['primary'])))
        gamethread.delayed(0, es.sexec, (userid, 'use slot1'))
